
;simple trace stack test - dedndave

;----------------------------------------------------------------------------------------------------

        .XCREF
        .NOLIST
        INCLUDE \masm32\include\masm32rt.inc
        .586
        INCLUDE \masm32\macros\timers.asm
        .LIST

;----------------------------------------------------------------------------------------------------

LOOP_COUNT = 2000

;----------------------------------------------------------------------------------------------------

        .CODE

_main   PROC

;-------------------------------------

;display CPU type

        push    1
        call    ShowCpu

;-------------------------------------

;select a single core

        INVOKE  GetCurrentProcess
        INVOKE  SetProcessAffinityMask,eax,1

;-------------------------------------

;test with pop|jmp ecx

        print   chr$(13,10,'JMP ECX last (100)',13,10,13,10)

        INVOKE  Sleep,500
        mov     ecx,5

test01: push    ecx
        counter_begin LOOP_COUNT,REALTIME_PRIORITY_CLASS

REPT 100
        xor     eax,eax
        call    Rec1
ENDM

        counter_end
        print   ustr$(eax),9,'clock cycles',13,10
        pop     ecx
        dec     ecx
        jnz     test01

;-------------------------------------

;test with ret

        print   chr$(13,10,'RET all (100)',13,10,13,10)

        INVOKE  Sleep,500
        mov     ecx,5

test02: push    ecx
        counter_begin LOOP_COUNT,REALTIME_PRIORITY_CLASS

REPT 100
        xor     eax,eax
        call    Rec2
ENDM

        counter_end
        print   ustr$(eax),9,'clock cycles',13,10
        pop     ecx
        dec     ecx
        jnz     test02

;-------------------------------------

        print   chr$(13,10,'JMP ECX all (100)',13,10,13,10)

        INVOKE  Sleep,500
        mov     ecx,5

test03: push    ecx
        counter_begin LOOP_COUNT,REALTIME_PRIORITY_CLASS

REPT 100
        xor     eax,eax
        call    Rec3
ENDM

        counter_end
        print   ustr$(eax),9,'clock cycles',13,10
        pop     ecx
        dec     ecx
        jnz     test03

;-------------------------------------

        print   chr$(13,10,'JMP ECX mostly (100)',13,10,13,10)

        INVOKE  Sleep,500
        mov     ecx,5

test04: push    ecx
        counter_begin LOOP_COUNT,REALTIME_PRIORITY_CLASS

REPT 100
        xor     eax,eax
        call    Rec4
ENDM

        counter_end
        print   ustr$(eax),9,'clock cycles',13,10
        pop     ecx
        dec     ecx
        jnz     test04

;-------------------------------------

        print   chr$(13,10,'RET mostly (100)',13,10,13,10)

        INVOKE  Sleep,500
        mov     ecx,5

test05: push    ecx
        counter_begin LOOP_COUNT,REALTIME_PRIORITY_CLASS

REPT 100
        xor     eax,eax
        call    Rec5
ENDM

        counter_end
        print   ustr$(eax),9,'clock cycles',13,10
        pop     ecx
        dec     ecx
        jnz     test05

;-------------------------------------

;wait for a keypress and exit

        print   chr$(13,10)
        inkey
        exit

_main   ENDP

;----------------------------------------------------------------------------------------------------

        ALIGN   16

Rec1    PROC

        inc     eax
        cmp     eax,5
        jz      rec1_1
        cmp     eax,10
        jae     Rec1_0

rec1_1: call    Rec1    ; 0 .. 9 case
        ret

Rec1_0: pop     ecx     ; >= 10 case
        jmp     ecx

Rec1    ENDP

;----------------------------------------------------------------------------------------------------

        ALIGN   16

Rec2    PROC

        inc     eax
        cmp     eax,5
        jz      Rec2_1
        cmp     eax,10
        jae     Rec2_0

Rec2_1: call    Rec2    ; 0 .. 9 case
Rec2_0: ret             ; >= 10 case

Rec2    ENDP

;----------------------------------------------------------------------------------------------------

        ALIGN   16

Rec3    PROC

        inc     eax
        cmp     eax,5
        jz      Rec3_1
        cmp     eax,10
        jae     Rec3_0

Rec3_1: call    Rec3    ; 0 .. 9 case
Rec3_0: pop     ecx     ; >= 10 case
        jmp     ecx

Rec3    ENDP

;----------------------------------------------------------------------------------------------------

        ALIGN   16

Rec4    PROC

        inc     eax
        cmp     eax,5
        jz      Rec4_1
        cmp     eax,10
        jae     Rec4_0

        call    Rec4    ; 0 .. 4, 6 .. 9 case
Rec4_0: pop     ecx     ; >= 10 case
        jmp     ecx

Rec4_1: call    Rec4    ; 5 case
        ret

Rec4    ENDP

;----------------------------------------------------------------------------------------------------

        ALIGN   16

Rec5    PROC

        inc     eax
        cmp     eax,5
        jz      Rec5_1
        cmp     eax,10
        jae     Rec5_0

        call    Rec5    ; 0 .. 5, 6 .. 9 case
Rec5_0: ret             ; >= 10 case


Rec5_1: call    Rec5    ; 5 case
        pop     ecx
        jmp     ecx

Rec5    ENDP

;----------------------------------------------------------------------------------------------------

;ShowCpu proc courtesy of Jochen, JJ2007

ShowCpu proc	; mode:DWORD
COMMENT @ Usage:
  push 0, call ShowCpu	; simple, no printing, just returns SSE level
  push 1, call ShowCpu	; prints the brand string and returns SSE level@
  pushad
  sub esp, 80	; create a buffer for the brand string
  mov edi, esp		; point edi to it
  xor ebp, ebp
  .Repeat
  	lea eax, [ebp+80000002h]
	db 0Fh, 0A2h	; cpuid 80000002h-80000004h
	stosd
	mov eax, ebx
	stosd
	mov eax, ecx
	stosd
	mov eax, edx
	stosd
	inc ebp
  .Until ebp>=3
  push 1
  pop eax
  db 0Fh, 0A2h		; cpuid 1
  xor ebx, ebx		; CpuSSE
  xor esi, esi		; add zero plus the carry flag
  bt edx, 25		; edx bit 25, SSE1
  adc ebx, esi
  bt edx, 26		; edx bit 26, SSE2
  adc ebx, esi
  bt ecx, esi		; ecx bit 0, SSE3
  adc ebx, esi
  bt ecx, 9			; ecx bit 9, SSE4
  adc ebx, esi
  dec dword ptr [esp+4+32+80]	; dec mode in stack
  .if Zero?
	mov edi, esp	; restore pointer to brand string
  	.Repeat				
		.Break .if byte ptr [edi]!=32	; mode was 1, so show a string but skip leading blanks
		inc edi
	.Until 0
	.if byte ptr [edi]<32
		print chr$("pre-P4")
	.else
		print edi	; CpuBrand
	.endif
	.if ebx
		print chr$(32, 40, "SSE")	; info on SSE level, 40=(
		print str$(ebx), 41, 13, 10	; 41=)
	.endif
  .endif
  add esp, 80		; discard brand buffer (after printing!)
  mov [esp+32-4], ebx	; move ebx into eax stack position - returns eax to main for further use
  ifdef MbBufferInit
	call MbBufferInit
  endif
  popad
  ret 4
ShowCpu endp

;----------------------------------------------------------------------------------------------------

        END     _main

